Search results

Resize Images before Uploading it to the Server in JavaScript (ES5) Uploader control

06 Jun 2023 / 5 minutes to read

You can customize the dimension of the images before uploading it to the server. By using selected event, you can get the selected file information as type of an object. From the obtained image file information, create a new canvas and render an image with the custom dimensions. Refer the corresponding code snippet as follows.

Copied to clipboard
<div id='upload'>
<!-- Initialize Uploader -->
    <input type='file' id='customUI' name='UploadFiles' />
</div>
<style>
.upload-success {color: #2bc700;}
#upload {
    width: 450px;
    margin: auto 400px;
}
.e-upload {
    width: 100%;
    margin-top: 50px;
}
.upload-list-root {
    display: inline-block;
    width: 450px;
}
.ul-element {
    list-style: none;
    padding-left: 0px;
    width: 100%;
}
.file-name-container {
    width: 100%;
}

.file-name {
    padding: 8px 6px 8px 4px;
    font-size:13px;
    width:100px;
    display: inline-block;
    text-overflow: ellipsis;
    overflow: hidden;
    white-space: nowrap;
    position: relative;
    top: 2px
}

.file-size {
    padding: 4px 0px;
    font-size: 13px;
    display: initial;
    position: relative;
    top: -8px;
}

.file-lists {
    border: 1px solid lightgray;
    padding: 0px 6px 0px 14px;
    margin-top: 15px;
    position: relative;
    background: rgba(0, 0, 0, 0.04);
}

span.file-status-container {
    padding: 10px 26px;
    font-size: 13px;
    position: relative;
    top: 0px;
    right: 60px;
    float: right;
}

.file-status-container, .file-size, .file-name {
    font-family: "Helvetica Neue", "Helvetica", "Arial", "sans-serif";
}
span.progress-bar-container {
    display: block;
    float: right;
    height: 20px;
    right: 50px;
    top: 11px;
    position: relative;
    right: 107px;
    width: 139px
}

.progress{
    width: 100%;
    height: 15px;
    -webkit-appearance: none;
}

.file-status-container {
    display: none;
}

.close-icon-container
{
    cursor: pointer;
    font-size: 11px;
    height: 24px;
    margin: 0 12px;
    padding: 0;
    position: absolute;
    right: 0;
    width: 24px;
    top: 8px;
}
.close-icon-container.e-icons::before {
    left: 6px;
    position: inherit;
    top: 6px;
    content: '\e932';
}

progress::-webkit-progress-bar {
    border: 1px solid lightgrey;
    background-color: #ffffff;
    border-radius: 2px;
}
progress::-webkit-progress-value {
    border-radius: 2px;
    background-color: skyblue;
}
</style>
Copied to clipboard
/**
 * Pre-resized image before upload
 */
import { Uploader, FileInfo } from '@syncfusion/ej2-inputs';
import { detach, isNullOrUndefined, createElement, EventHandler  } from '@syncfusion/ej2-base';

let uploadObj: Uploader = new Uploader({
    autoUpload: false,
    asyncSettings: {
        saveUrl: 'https://ej2.syncfusion.com/services/api/uploadbox/Save',
        removeUrl: 'https://ej2.syncfusion.com/services/api/uploadbox/Remove'
    },
    allowedExtensions: 'image/*',
    selected: onFileSelect,
    progress : onFileUpload,
    success : onuploadSuccess,
    failure : onuploadFailed
});
uploadObj.appendTo('#customUI');

let newImage;
let parentElement : HTMLElement;
let ul: HTMLElement;
let proxy : any;

function onFileSelect(args : any) : void  {
    args.cancel = true;
    proxy = this;
    if ( isNullOrUndefined(document.getElementById('upload').querySelector('.upload-list-root'))) {
        parentElement = createElement('div', { className: 'upload-list-root' });
        ul = createElement('ul', {className: 'ul-element' });
        parentElement.appendChild(ul);
        document.getElementById('upload').appendChild(parentElement);
    }
    for (let i : number = 0; i < args.filesData.length; i++) {
        formSelectedData(args.filesData[i]);
    }
    this.filesData = this.filesData.concat(args.filesData);

    let file: FileInfo = args.filesData[0].rawFile;
    let width: number;
    let height: number;
    let img: any = document.createElement("img");
    let reader: any = new FileReader();
    reader.onload = function(e: any) { img.src = e.target.result; };
    reader.readAsDataURL(file);
    let imgs = new Image();
    img.onload = function() {
        width = this.width;
        height = this.height;
        onNewImg(height, width, img, args.filesData[0])
    }
    imgs.src = img.src;
}

    // to create canvas and update our custom dimensions
    function onNewImg(height: any, width: any, img: any, file: any) {
        let canvas: HTMLCanvasElement = document.createElement("canvas");
        let ctx: any = canvas.getContext("2d");
        ctx.drawImage(img, 0, 0);
        let MAX_WIDTH: any = 1000;
        let MAX_HEIGHT: any = 600;
        if (width > height) {
            if (width > MAX_WIDTH) {
                height *= MAX_WIDTH / width;
                width = MAX_WIDTH;
            }
        } else {
            if (height > MAX_HEIGHT) {
                width *= MAX_HEIGHT / height;
                height = MAX_HEIGHT;
            }
        }
        canvas.width = width;
        canvas.height = height;
        let ctx1 = canvas.getContext("2d");
        ctx1.drawImage(img, 0, 0, width, height);
        newImage = canvas.toDataURL("image/png");
        let blobBin = atob(newImage.split(',')[1]);
        let array = [];
        for(var i = 0; i < blobBin.length; i++) {
            array.push(blobBin.charCodeAt(i));
        }
        let newBlob = new Blob([new Uint8Array(array)], {type: 'image/png'});
        let newFile: any = createFile(newBlob, file);
        uploadObj.upload(newFile, true);
    }
    // To create File object to upload
    function createFile(image: any , file: any) {
        let newFile = {
            name: file.name,
            rawFile: image,
            size: image.size,
            type: file.type,
            validationMessage: '',
            statusCode: '1',
            status: 'Ready to Upload'
        }
        return newFile;
    }

function formSelectedData ( selectedFiles : FileInfo ) : void {
    let liEle : HTMLElement = createElement('li',  { className: 'file-lists', attrs: {'data-file-name' : selectedFiles.name} });
    let fileNameContainer : HTMLElement = createElement('span', {className: 'file-name-container' });
    let fileName : HTMLElement = createElement('span', {className: 'file-name ' });
    fileName.innerHTML = selectedFiles.name;
    let fileSize : HTMLElement = createElement('span', {className: 'file-size ' });
    fileSize.innerHTML = proxy.bytesToSize(selectedFiles.size);
    liEle.appendChild(fileName);
    liEle.appendChild(fileSize);
    let fileStatusContainer : HTMLElement = createElement('span', {className: 'file-status-container' });
    let fileStatus : HTMLElement = createElement('span', {className: 'file-status'});
    fileStatusContainer.appendChild(fileStatus);
    let progressbarContainer : HTMLElement = createElement('span', {className: 'progress-bar-container'});
    let progressBar : HTMLElement = createElement('progress', {className: 'progress', attrs: {value : '0', max : '100'}} );
    progressbarContainer.appendChild(progressBar);
    let closeIconContainer : HTMLElement = createElement('span', {className: 'e-icons close-icon-container'});
    EventHandler.add(closeIconContainer, 'click', removeFiles, proxy);
    liEle.appendChild(fileStatusContainer);
    liEle.appendChild(progressbarContainer);
    liEle.appendChild(closeIconContainer);
    ul.appendChild(liEle);
    proxy.fileList.push(liEle);
}

function onFileUpload(args : any) : void {
    let li : Element = document.getElementById('upload').querySelector('[data-file-name="' + args.file.name + '"]');
    let progressValue : number = Math.round((args.e.loaded / args.e.total) * 100);
    li.getElementsByTagName('progress')[0].value = progressValue;
}

function onuploadSuccess(args : any): void {
    let li : Element = document.getElementById('upload').querySelector('[data-file-name="' + args.file.name + '"]');
    if (!isNullOrUndefined(li.querySelector('.progress-bar-container'))) {
        detach(li.querySelector('.progress-bar-container'));
    }
    if (args.operation === 'upload') {
        li.querySelector('.file-status').classList.add('upload-success');
        li.querySelector('.file-status').innerHTML = args.file.status;
        li.querySelector('.file-status-container').setAttribute('style', 'display: inline-block');
    }
    if (args.operation === 'remove') {
        let index: number = this.fileList.indexOf(li);
        this.fileList.splice(index, 1);
        this.filesData.splice(index, 1);
        detach(li);
    }
}

function onuploadFailed(args : any): void {
    let li : Element = document.getElementById('upload').querySelector('[data-file-name="' + args.file.name + '"]');
    li.querySelector('.file-status').innerHTML = args.file.status;
    if (args.operation === 'upload') {
        detach(li.querySelector('.progress-bar-container'));
        li.querySelector('.file-status-container').setAttribute('style', 'display: initial');
    }
}

function removeFiles(args : any): void {
    let index: any = proxy.fileList.indexOf(args.currentTarget.parentElement);
    return proxy.remove(proxy.filesData[index]);
}

You can also explore JavaScript File Upload feature tour page for its groundbreaking features. You can also explore our JavaScript File Upload example to understand how to browse the files which you want to upload to the server.

Resize images before uploading it to the server in React Uploader component

30 Jan 202321 minutes to read

You can customize the dimension of the images before uploading it to the server.
By using selected event, you can get the selected file information as type of an object. From the obtained image file information, create a new canvas and render an image with the custom dimensions. Refer the corresponding code snippet as follows.

import { Browser, createElement, detach, EventHandler, isNullOrUndefined } from '@syncfusion/ej2-base';
import { createSpinner, hideSpinner, showSpinner } from '@syncfusion/ej2-popups';
import { FileInfo, RemovingEventArgs, UploaderComponent } from '@syncfusion/ej2-react-inputs';
import * as React from 'react';

export default class App extends React.Component<{}, {}> {
  public uploadObj: UploaderComponent;
  public newImage: any;
  public parentElement: HTMLElement;
  public proxy: any;
  public progressbarContainer: HTMLElement;
  public filesDetails: FileInfo[] = [];
  public filesList: HTMLElement[] = [];
  public path: object = {
    removeUrl: 'https://ej2.syncfusion.com/services/api/uploadbox/Remove',
    saveUrl: 'https://ej2.syncfusion.com/services/api/uploadbox/Save'
  }
  constructor(props: any) {
    super(props);
    this.onSuccess= this.onSuccess.bind(this);
    this.onRemoveFile= this.onRemoveFile.bind(this);
    this.onFileSelect= this.onFileSelect.bind(this);
    this.onFileUpload = this.onFileUpload.bind(this);
    this.onUploadFailed= this.onUploadFailed.bind(this);
  }
  public onSuccess(args: any): void {
    const spinnerElement: HTMLElement = document.getElementById("dropArea") as HTMLElement;
    const li: HTMLElement = (document.getElementById("dropArea") as HTMLElement).querySelector('[data-file-name="' + args.file.name + '"]') as HTMLElement;
    if (args.operation === "upload") {
      (li.querySelector(".close-icon-container") as HTMLElement).classList.add("delete-icon");
      detach(li.getElementsByTagName("progress")[0]);
      (li.querySelector(".file-size") as HTMLElement).style.display =
        "inline-block";
      (li.querySelector(".file-name") as HTMLElement).style.color = "green";
      (li.querySelector(".e-icons") as HTMLElement).onclick = () => {
        createSpinner({ target: spinnerElement, width: "25px" });
        showSpinner(spinnerElement);
      };
      (li.querySelector(".close-icon-container") as HTMLElement).onkeydown = (
        e: any
      ) => {
        if (e.keyCode === 13) {
          createSpinner({ target: spinnerElement, width: "25px" });
          showSpinner(spinnerElement);
        }
      };
    } else {
      this.filesDetails.splice(this.filesList.indexOf(li), 1);
      this.filesList.splice(this.filesList.indexOf(li), 1);
      this.uploadObj.element.value = "";
      detach(li);
      hideSpinner(spinnerElement);
      detach(spinnerElement.querySelector(".e-spinner-pane") as HTMLElement);
    }
    EventHandler.add(li.querySelector(".close-icon-container") as HTMLElement, "click", this.removeFiles, this);
  }

  public onFileSelect(args: any): void {
    args.cancel = true;
    const proxy = this;
    if (
      isNullOrUndefined(
        (document.getElementById("dropArea") as HTMLElement).querySelector(".upload-list-root") as HTMLElement
      )
    ) {
      this.parentElement = createElement("div", {
        className: "upload-list-root"
      });
      this.parentElement.appendChild(
        createElement("ul", { className: "ul-element" })
      );
      (document.getElementById("dropArea") as HTMLElement).appendChild(this.parentElement);
    }
    for (const fileData of args.filesData) {
      this.formSelectedData(fileData, this); // create the LI element for each file Data
    }
    // for (let i: number = 0; i < args.filesData.length; i++) {
    //   this.formSelectedData(args.filesData[i], this); // create the LI element for each file Data
    // }
    this.filesDetails = this.filesDetails.concat(args.filesData);
    const file: FileInfo = args.filesData[0].rawFile;
    let width: number;
    let height: number;
    const img: any = document.createElement("img");
    const reader: any = new FileReader();
    reader.onload = (e: any) => {
      img.src = e.target.result;
    };
    reader.readAsDataURL(file);
    const imgs = new Image();
    img.onload = function() {
      width = this.width;
      height = this.height;
      proxy.onNewImg(height, width, img, args.filesData[0]);
    };
    imgs.src = img.src;
  }

  // to create canvas and update our custom dimensions
  public onNewImg(height: number, width: number, img: any, file: any) {
    const canvas: HTMLCanvasElement = document.createElement("canvas");
    const ctx: any = canvas.getContext("2d");
    ctx.drawImage(img, 0, 0);
    const MAX_WIDTH: any = 1000;
    const MAX_HEIGHT: any = 600;
    if (width > height) {
      if (width > MAX_WIDTH) {
        height *= MAX_WIDTH / width;
        width = MAX_WIDTH;
      }
    } else {
      if (height > MAX_HEIGHT) {
        width *= MAX_HEIGHT / height;
        height = MAX_HEIGHT;
      }
    }
    canvas.width = width;
    canvas.height = height;
    const ctx1 = canvas.getContext("2d") as CanvasRenderingContext2D;
    ctx1.drawImage(img, 0, 0, width, height);
    this.newImage = canvas.toDataURL("image/png");
    const blobBin = atob(this.newImage.split(",")[1]);
    const array = [];
    for (let i = 0; i < blobBin.length; i++) {
      array.push(blobBin.charCodeAt(i));
    }
    const newBlob = new Blob([new Uint8Array(array)], { type: "image/png" });
    const newFile: any = this.createFile(newBlob, file);
    this.uploadObj.upload(newFile, true);
  }
  // To create File object to upload
  public createFile(image: any, file: any) {
    const newFile = {
      name: file.name,
      rawFile: image,
      size: image.size,
      status: "Ready to Upload",
      statusCode: "1",
      type: file.type,
      validationMessage: ""
    };
    return newFile;
  }

  public formSelectedData(selectedFiles: FileInfo, proxy: any): void {
    const liEle: HTMLElement = createElement("li", {
      attrs: { "data-file-name": selectedFiles.name },
      className: "file-lists"
    });
    liEle.appendChild(
      createElement("span", {
        className: "file-name ",
        innerHTML: selectedFiles.name
      })
    );
    liEle.appendChild(
      createElement("span", {
        className: "file-size ",
        innerHTML: this.uploadObj.bytesToSize(selectedFiles.size)
      })
    );
    if (selectedFiles.statusCode === "1") {
      this.progressbarContainer = createElement("span", {
        className: "progress-bar-container"
      });
      this.progressbarContainer.appendChild(
        createElement("progress", {
          attrs: { value: "0", max: "100" },
          className: "progress"
        })
      );
      liEle.appendChild(this.progressbarContainer);
    } else {
      (liEle.querySelector(".file-name") as HTMLElement).classList.add("upload-fails");
    }
    const closeIconContainer: HTMLElement = createElement("span", {
      className: "e-icons close-icon-container"
    });
    EventHandler.add(closeIconContainer, "click", this.removeFiles, proxy);
    liEle.appendChild(closeIconContainer);
    (document.querySelector(".ul-element") as HTMLElement).appendChild(liEle);
    this.filesList.push(liEle);
  }

  public onFileUpload(args: any): void {
    const li: Element = (document.getElementById("dropArea") as HTMLElement).querySelector('[data-file-name="' + args.file.name + '"]') as HTMLElement;
    EventHandler.remove(li.querySelector(".close-icon-container") as HTMLElement, "click", this.removeFiles );
    const progressValue: number = Math.round(
      (args.e.loaded / args.e.total) * 100
    );
    if (!isNaN(progressValue)) {
      li.getElementsByTagName("progress")[0].value = progressValue; // Updating the progress bar value
    }
  }

  public onUploadFailed(args: any): void {
    const li: Element = (document.getElementById("dropArea") as HTMLElement).querySelector('[data-file-name="' + args.file.name + '"]') as HTMLElement;
    EventHandler.add(li.querySelector(".close-icon-container") as HTMLElement, "click", this.removeFiles, this);
    (li.querySelector(".file-name ") as HTMLElement).classList.add("upload-fails");
    if (args.operation === "upload") {
      detach(li.querySelector(".progress-bar-container") as HTMLElement);
    }
  }
  public removeFiles(args: any): void {
    const status: string = this.filesDetails[
      this.filesList.indexOf(args.currentTarget.parentElement)
    ].statusCode;
    if (status === "2") {
      this.uploadObj.remove(
        this.filesDetails[
          this.filesList.indexOf(args.currentTarget.parentElement)
        ]
      );
    } else {
      detach(args.currentTarget.parentElement);
    }
  }
  public onRemoveFile(args: RemovingEventArgs): void {
    args.postRawFile = false;
  }

  public componentDidMount() {
    setTimeout(() => {
  (document.getElementById("browse") as HTMLElement).onclick = () => {
      ((document.getElementsByClassName("e-file-select-wrap")[0] as HTMLElement).querySelector("button") as HTMLElement).click();
      return false;
    };
    this.uploadObj.element.setAttribute("name", "UploadFiles");
    this.uploadObj.dropArea = document.getElementsByClassName(
      "template_wrapper"
    )[0] as HTMLElement;
    this.uploadObj.dataBind();
    if (Browser.isDevice) {
      (this.uploadObj.dropArea.querySelector(
        "drop"
      ) as HTMLElement).style.padding = "4% 13%";
    };
  })
}
public render() {
    return (
            <div className="template_wrapper">
              {/* Render Uploader */}
              <div id="dropArea" className="dropArea">
                <span id="drop" className="file-name-span drop">
                  {" "}
                  Drop files here or <a href="" id="browse">
                    <u>Browse</u>
                  </a>{" "}
                </span>
                <UploaderComponent id="fileUpload" type="file" ref={upload => { this.uploadObj = upload! }}
                  success={this.onSuccess}
                  removing={this.onRemoveFile}
                  selected={this.onFileSelect}
                  progress={this.onFileUpload} // Triggres when upload is in progress
                  failure={this.onUploadFailed} // Triggres when upload got failed
                  dropArea={
                    document.getElementsByClassName("template_wrapper")[0] as HTMLElement
                  }
                  asyncSettings = {this.path}
                  multiple = {false}
                  allowedExtensions={"image/*"}
                />
              </div>
            </div>)
  }
}
ReactDOM.render(<App />, document.getElementById("fileupload"));
<style>
.dropArea {
    min-height: 50px;
    padding-top: 15px;
    position: relative;
}

.drop {
    padding: 3% 30% 3%;
    display: inherit;
    border: 1px dashed #c3c3cc;
}

.template_wrapper {
    max-width: 400px;
    margin: auto;
}

.template_wrapper .file-name-span {
    font-size:  14px;
}

.template_wrapper .e-file-select-wrap {
    display: none;
}

.template_wrapper .e-upload {
    float: none;
    border: none;
}

.template_wrapper .ul-element {
    list-style: none;
    width: 100%;
    padding-left: 0;
}

.template_wrapper .file-name {
    padding: 8px 6px 8px 0;
    font-size: 13px;
    width: 46%;
    display: inline-block;
    position: relative;
    top: 4px;
}

.template_wrapper .file-size {
    padding: 4px;
    font-size: 13px;
    width: 18%;
    display: inline-block;
    position: relative;
}

.template_wrapper .file-lists {
    border: 1px solid lightgray;
    padding: 0 6px 0 14px;
    margin-top: 15px;
    position: relative;
    background: rgba(0, 0, 0, 0.04);
}

.template_wrapper .file-size,.template_wrapper .file-name {
    font-family: "Helvetica Neue", "Helvetica", "Arial", "sans-serif";
    text-overflow: ellipsis;
    overflow: hidden;
    white-space: nowrap
}
.template_wrapper span.progress-bar-container {
    display: block;
    float: right;
    height: 20px;
    right: 13%;
    top: 14px;
    position: relative;
    width: 20%;
}

.template_wrapper .progress{
    width: 100%;
    height: 15px;
    -webkit-appearance: none;
}

.template_wrapper .close-icon-container
{
    cursor: pointer;
    font-size: 11px;
    height: 26px;
    margin: 0 12px 0 22px;
    padding: 0;
    position: absolute;
    right: 0;
    width: 26px;
    top: 6px;
}

.template_wrapper .close-icon-container.e-icons::before {
    left: 7px;
    position: inherit;
    top: 7px;
    content: '\e932';
}

.template_wrapper .close-icon-container.delete-icon::before {
    content: '\e94a';
}

.template_wrapper .close-icon-container:hover {
    background-color: rgba(0, 0, 0, 0.12);
    border-color: transparent;
    border-radius: 50%;
    box-shadow: 0 0 0 transparent;
}

.template_wrapper .upload-success {
    color: #2bc700;
}

.template_wrapper .upload-fails {
    color: #f44336;
}

.template_wrapper progress::-webkit-progress-bar {
    border: 1px solid lightgrey;
    background-color: #ffffff;
    border-radius: 2px;
}
#dropArea progress {
    border: 1px solid lightgrey;
    background-color: #ffffff;
    border-radius: 2px;
}
.template_wrapper span a {
    color:#ff4081;
}
</style>

You can also explore React File Upload feature tour page for its groundbreaking features. You can also explore our React File Upload example to understand how to browse the files which you want to upload to the server.